include	clib.inc
include	iost.inc
include	unzip.inc
include	string.inc
include	errno.inc
include	math.inc
include	conio.inc

	.186

USE_CRYPT = 1	; Password encryption

  if USE_CRYPT
	extrn	password:	byte
	extrn	enterpassword:	byte
  endif
	extrn	cp_warning: 	byte
	extrn	zip_attrib: 	word
	extrn	IDD_CRCERROR:	word

_TEXT	SEGMENT

if USE_CRYPT

CRC32	PROC
	mov	dx,bx	; cx:bx, ax
	xor	ax,dx
	xor	ah,ah
	shl	ax,2
	mov	bx,ax
	mov	dl,dh
	mov	dh,cl
	mov	cl,ch
	mov	ch,0
	mov	ax,word ptr [bx+crctab]
	xor	ax,dx
	mov	dx,word ptr [bx+crctab+2]
	xor	dx,cx
	ret
CRC32	ENDP

update_keys PROC
	push	cx
	mov	bx,key0_ax
	mov	cx,key0_dx
	push	ax
	call	CRC32
	mov	key0_ax,ax
	mov	key0_dx,dx
	mov	dx,key1_dx
	mov	ah,0
	add	ax,key1_ax
	adc	dx,0
	mov	cx,0808h
	mov	bx,8405h
	call	MUL32
	add	ax,1
	adc	dx,0
	mov	key1_ax,ax
	mov	key1_dx,dx
	mov	bx,key2_ax
	mov	cx,key2_dx
	mov	al,dh
	xor	dx,dx
	mov	ah,00h
	call	CRC32
	mov	key2_ax,ax
	mov	key2_dx,dx
	pop	ax
	pop	cx
	ret
update_keys ENDP

decryptbyte PROC
	mov	bx,key2_ax
	or	bx,2
	mov	dx,bx
	xor	dx,1
	mov	ax,bx
	mul	dx
	mov	al,ah
	ret
decryptbyte ENDP

init_keys PROC
	mov	key0_ax,5678h
	mov	key0_dx,1234h
	mov	key1_ax,6789h
	mov	key1_dx,2345h
	mov	key2_ax,7890h
	mov	key2_dx,3456h
	push	si
	mov	si,offset password
    init_keys_00:
	xor	ax,ax
	mov	al,[si]
	inc	si
	or	al,al
	jz	init_keys_01
	call	update_keys
	jmp	init_keys_00
    init_keys_01:
	pop	si
	ret
init_keys ENDP

	public	odecrypt

odecrypt PROC
	push	si
	xor	si,si
    odecrypt_00:
	call	decryptbyte
	les	bx,dword ptr STDI
	add	bx,si
	xor	es:[bx],al
	mov	al,es:[bx]
	call	update_keys
	inc	si
	cmp	si,STDI.ios_c
	jl	odecrypt_00
	pop	si
	ret
odecrypt ENDP

test_password PROC
	push	bp
	sub	sp,12
	mov	bp,sp
	push	si
	call	init_keys
	push	ss
	push	bp
	pushm	[bp+4+12]
	push	12
	call	memcpy
	xor	si,si
    test_password_00:
	call	decryptbyte
	xor	[bp+si],al
	mov	al,[bp+si]
	call	update_keys
	inc	si
	cmp	si,12
	jl	test_password_00
	mov	ax,zip_attrib
	and	ax,_A_EXTLOCHD
	mov	ax,zip_local.lz_time
	jnz	test_password_01
	mov	ax,zip_local.lz_crc_dx
    test_password_01:
	cmp	ah,[bp+11]
	je	test_password_02
	mov	ax,-1
	jmp	test_password_04
    test_password_02:
	mov	cx,STDI.ios_c
	sub	cx,12
	les	si,dword ptr STDI
	add	si,12
    test_password_03:
	call	decryptbyte
	xor	es:[si],al
	mov	al,es:[si]
	call	update_keys
	inc	si
	dec	cx
	jnz	test_password_03
	xor	ax,ax
    test_password_04:
	pop	si
	add	sp,12
	pop	bp
	ret	4
test_password ENDP

zip_decrypt PROC
	push	bp
	sub	sp,12
	mov	bp,sp
	push	si
	push	di
	mov	si,12
	mov	di,bp
    decrypt_00:
	call	ogetc
	mov	[di],al
	inc	di
	dec	si
	jnz	decrypt_00
	push	ss
	push	bp
	call	test_password
	or	ax,ax
	jz	decrypt_02
	mov	password,0
	push	ds
	push	offset enterpassword
	push	ds
	push	offset password
	push	32
	push	80
	call	tgetline
	or	ax,ax
	jz	decrypt_01
	xor	ax,ax
	cmp	password,al
	jz	decrypt_01
	push	ss
	push	bp
	call	test_password
	or	ax,ax
	jz	decrypt_02
	xor	ax,ax
    decrypt_01:
	pop	di
	pop	si
	add	sp,12
	pop	bp
	ret
    decrypt_02:
	mov	ax,1
	jmp	decrypt_01
zip_decrypt ENDP

endif ; USE_CRYPT

zip_free PROC
	mov	ax,OSTDI
	call	ofreest
	mov	ax,OSTDO
	call	ofreest
	mov	ax,ER_MEM
	ret
zip_free ENDP

zip_alloc PROC
	mov	STDI.ios_file,ax
	mov	STDO.ios_file,dx
	mov	ax,OSTDI
	call	oinitst
	jz	zip_alloc_01
	mov	ax,OSTDO
	call	oinitst
	jnz	zip_alloc_03
	jmp	zip_free
    zip_alloc_03:
	mov	STDI.ios_flag,IO_USEBITS
	mov	STDO.ios_flag,IO_UPDTOTAL or IO_USEUPD or IO_USECRC
	xor	ax,ax
	test	zip_attrib,_A_ENCRYPTED
  if USE_CRYPT
	jz	zip_alloc_00
	call	ogetc
	jz	zip_alloc_02
	dec	STDI.ios_i
	call	zip_decrypt
	or	ax,ax
	jz	zip_alloc_02
	or	STDI.ios_flag,IO_CRYPT
	xor	ax,ax
  else
	jnz	zip_alloc_02
  endif
    zip_alloc_00:
	ret
    zip_alloc_01:
	mov	ax,ER_MEM
	ret
    zip_alloc_02:
	call	zip_free
	mov	ax,-1
	ret
zip_alloc ENDP

	public	unzip

unzip	PROC	DIST	; AX: zip file handle
	push	si  	; DX: out file handle
	call	zip_alloc
	mov	si,ax
	or	ax,ax
	jnz	unzip_free
	mov	ax,zip_local.lz_method
	or	ax,ax
	jz	unzip_stored
	cmp	ax,8
	je	unzip_inflate
	cmp	ax,6
	je	unzip_explode
    unzip_warning:
	push	zip_local.lz_method
	pushm	[sys_errlist+(ENOSYS*DPTRZ)]
	mov	dx,offset format_sL_02X
	mov	ax,offset cp_warning
	call	@ermsgt
	add	sp,6
	mov	si,3
	jmp	unzip_free
    unzip_stored:
	mov	STDI.ios_flag,IO_USECRC
	push	zip_local.lz_fsize_dx
	push	zip_local.lz_fsize_ax
	xor	si,si
	call	ocopy
	jnz	unzip_free
	mov	si,ax
	jmp	unzip_free
    unzip_inflate:
	call	zip_inflate
	mov	si,ax
	jmp	unzip_free
    unzip_explode:
	call	zip_explode
	mov	si,ax
    unzip_free:
	call	zip_free
	test	STDO.ios_flag,IO_ERROR
	jnz	unzip_er_disk
	or	si,si
	jnz	unzip_end
	mov	ax,STDO.ios_bb_dx
	not	ax
	cmp	ax,zip_local.lz_crc_dx
	jne	unzip_er_crc
	mov	ax,STDO.ios_bb_ax
	not	ax
	cmp	ax,zip_local.lz_crc_ax
	je	unzip_end
    unzip_er_crc:
	push	ds
	push	IDD_CRCERROR
	call	rsmodal
	or	ax,ax
	jnz	unzip_end
	mov	si,ER_CRCERR
    unzip_end:
	mov	ax,si
	pop	si
	ret
    unzip_er_disk:
	mov	si,ER_DISK
	jmp	unzip_end
unzip	ENDP

_TEXT	ENDS

_DATA	SEGMENT

format_sL_02X	db "%s",10,"'%02X'",0

if USE_CRYPT
 key0_ax	dw ?
 key0_dx	dw ?
 key1_ax	dw ?
 key1_dx	dw ?
 key2_ax	dw ?
 key2_dx	dw ?
endif

_DATA	ENDS

	END
